#ifndef FARM_H
#define FARM_H
/* This file contains function prototypes for the farming constructs at the
client end (Farmer, Worker).
*/


int pvm_farm_init(char *farm_name) ; /* Farmer */
int pvm_get_worker_class_id(char *farm_name, char *wcname) ; /* Farmer */
int pvm_init_worker_class(char *farm_name, char *wcname) ;   /* Worker */

int pvm_send_work_packet(int worker_class_id) ;  /* Farmer */
int pvm_recv_work_packet(void) ;  		 /* Worker */

int pvm_send_reply_packet(void) ; 		 /* Farmer */
int pvm_recv_reply_packet(int worker_class_id) ; /* Worker */

int pvm_farm_terminate(char *farm_name); /* Farmer */
int pvm_stop_farmd(void); 
int pvm_start_farmd(void); 
#define SERVER_NAME 	"app"

#define	PvmFarmHasTerminated	-10
#define PvmFarmNamePresent	-11
#define	PvmNoSuchFarm		-12
#define	PvmNotFarmOwner		-13

#endif
