#ifndef FARM_H
#define FARM_H
/* This file contains function prototypes for the farming constructs at the
client end (Farmer, Worker).
*/


int pvm_farm_init(char *farm_name) ; /* Farmer */
int pvm_get_worker_class_id(char *farm_name, char *wcname) ; /* Farmer */
int pvm_init_worker_class(char *farm_name, char *wcname) ;   /* Worker */

int pvm_send_work_packet(int worker_class_id) ;  /* Farmer */
int pvm_recv_work_packet(void) ;  		 /* Worker */

int pvm_send_reply_packet(void) ; 		 /* Farmer */
int pvm_recv_reply_packet(int worker_class_id) ; /* Worker */

int	pvm_leave_farm(void);		/* Worker */

int pvm_farm_terminate(char *farm_name); /* Farmer */
int pvm_stop_farmd(void); 	/* Farmer */
int pvm_start_farmd(void); 	/* Farmer */
#define SERVER_NAME 	"pvmfarmd"

#define	PvmFarmHasTerminated	-10
#define PvmFarmNamePresent	-11
#define	PvmNoSuchFarm		-12
#define	PvmNotFarmOwner		-13

#define ASSERT(condition)                                                     \
    if (condition < 0) {                                                      \
        fprintf(stderr, "Assertion failed: line %d, file \"%s\"\n",           \
                __LINE__, __FILE__);                                          \
	fflush(stderr);							      \
        exit(1);                                                              \
    }


#endif
