#ifndef FLIST_H
#define FLIST_H


// Class declarations. the definitions are separate.

class FItem {
public : 
	int	number_of_worker_classes; // associated with the farmer
	int	tid;	// the task id of the farmer
	FItem 	*next;
	WCList	*WCList_ptr; // pointer to a Worker Class List
	char	farmer_name[NAMELEN];
	FItem(char *name); // constructor
	~FItem(); // destructor
	} ;

class FList {
	
FItem *first_rec, *last_rec; // pointers to beginning and end of the list
int	no_of_items; // number of items in the list.

public :  // the methods of this class are
	FList(); // the constructor
	~FList(); // the destructor
	int	Append(char *name,int val); // to the end of the list. Return OK, ERROR
	FItem *	Search (char *name); // for element having value = val. NULL if not found, else return the FItem
	FItem *	SearchByTid (int val); // for element having tid = val. NULL if not found, else return the FItem
	int	Delete(char *name);  // the item having a particular value. OK/FAILURE
	FItem * Pop(void); // Remove the first item in the list
	int	Display(void); // For debugging. See the list OK/ERROR
	int 	EnrollWorkerClass(char *farm, char *wcname);   
		// returns wcid, or ERROR or FARMNOTCREATED
	};


#endif	
