#include "incl.h"
#include <pvm3.h>

int Server(void)
// This is the main loop of ther server. It accepts messages and displatches
// them for proper execution
{
int	bufid ; // of a message
int	request; // type of service to be given  
int	size, msgtag, ctid; // pvm_bufinfo parameters
int	wcid; // for sending a work packet to
int	ftid; // farmer task id to get from the worker task
char	name1[NAMELEN],name2[NAMELEN]; // any name


while(1)
{ //loop forever 
	// Wait for any message from farmer or workers
	bufid = pvm_mkbuf(PvmDataDefault);
	ASSERT(bufid); // Check if < 0

	info = pvm_setrbuf(bufid); 
	ASSERT(info); // Check if info < 0

	bufid = pvm_recv( -1, -1); // wildcard receive - ANY message!
	// This call blocks till the message has been received
	ASSERT(bufid); // Check if < 0

	info = pvm_bufinfo(bufid, &size, &msgtag, &ctid); // size of message,
				// message tag, client tid (sender tasks tid)
	ASSERT(info); // Check if < 0
	DEBUG("SR: received a message, size = %d, msgtag = %d, tid = %d\n",
			size, msgtag, ctid);
	

	// Now extract the service request (opcode) from the request
	info = pvm_upkint(&request,1,1); // 1 item, stride = 1 (1st elem in msg)
	ASSERT(info); // Check if < 0
	
	switch (request)
	{
	case INIT_FARM : 
			info = pvm_upkstr(name1); // Extract the farmer name
				// (2nd elem in msg)
			ASSERT(info); // Check if info < 0
			DEBUG("SR: request INIT_FARM, name=%s, tid = %x\n",
				name1,ctid);
			info = ProcessInitFarm(name1,ctid); 
			if(info == ERROR)
			{
				printf("ERROR in farmd : ProcessInitFarm returns an ERROR\n");
				pvm_exit();
				exit(1);
			}
// Check here to see if farm is present already.	
			break;
	case GET_WORKER_CLASS_ID : 
			info = pvm_upkstr(name1); // Extract farmer name,
				// (2nd elem in msg)
			ASSERT(info); // Check if info < 0

			info = pvm_upkstr(name2); // Extract worker_class name
				// (3rd elem in msg)
			ASSERT(info); // Check if info < 0

			DEBUG("SR: request GET_WORKER_CLASS_ID, fname =%s, wcname = %s, tid = %x\n", name1, name2, ctid);
			info = ProcessGetWorkerClassId(name1, name2,ctid); 
			// send farmer name, wc name, tid to enroll the worker
			// to send the worker class id to the client
			if(info == ERROR)
			{
				printf("ERROR in farmd : ProcessGetWorkerClass returns an ERROR\n");
				pvm_exit();
				exit(1);
			}
			break;

	case INIT_WORKER_CLASS :
			info = pvm_upkstr(name1); // Extract farmer name, 
				// (2nd elem in msg)
			ASSERT(info); // Check if info < 0

			info = pvm_upkstr(name2); // Extract worker class name
				// (3rd elem in msg)
			ASSERT(info); // Check if info < 0
			DEBUG("SR: request INIT_WORKER_CLASS, fname =%s, wcname = %s, tid = %x\n", name1, name2, ctid);
			info = ProcessInitWorkerClass(name1,name2,ctid); 
			// send the farmer name, wcname, and tid 
			if (info == ERROR)
			{
				printf("ERROR in farmd : ProcessInitWorkerClass returns ERROR\n");
				pvm_exit();
				exit(1);
			}
			break; 

	case FARM_TERMINATE :
			info = pvm_upkstr(name1); // Extract farmer name 
			ASSERT(info); // Check if info < 0

			info = ProcessFarmTerminate(name1, ctid); 
				// Send the farmer name and tid of process 

			break; 
	case SEND_WORK_PACKET :
			info = pvm_upkint(&wcid, 1, 1); // get worker classid
			ASSERT(info); // Check if info < 0

			DEBUG("SR: Send Work Packet : wcid = %d\n", wcid); 
			info = ProcessSendWorkPacket(ctid, wcid); // tell the wcid	
			if(info == ERROR)
			{
				printf("ERROR in farmd : ProcessSendWorkPacket returns an ERROR\n");
				pvm_exit();
				exit(1);
			}
			break;	

	case RECV_WORK_PACKET :
			info = pvm_upkint(&wcid, 1, 1); //get worker class id
			ASSERT(info); // Check if info < 0

			DEBUG("SR: Recv Work Packet : wcid = %d\n", wcid); 
			info = ProcessRecvWorkPacket(ctid, wcid);
			// send worker tid (ctid), wcid
			if(info == ERROR)
			{
				printf("ERROR in farmd : ProcessRecvWorkPacket returns an ERROR\n");
				pvm_exit();
				exit(1);
			}

			break; 
	case STOP_FARMD :
			DEBUG("SR : received a STOP_FARMD request\n");
			pvm_exit();
			exit(0);
			// Shutdown the daemon
	
			break;
	case LEAVE_FARM :
			info = pvm_upkint(&wcid, 1, 1); //get worker class id
			ASSERT(info); // Check if info < 0

			info = pvm_upkint(&ftid, 1, 1); // get farmer tid
			ASSERT(info); // Check if info < 0

			DEBUG("SR : received LEAVE_FARM request, farmtid = %d, wcid = %d, worker tid = %d\n", ftid, wcid, ctid); 
			info = ProcessLeaveFarm(ctid, ftid, wcid); // send the ids
			if(info == ERROR)
			{
				printf("ERROR in farmd : ProcessLeaveFarm returns an ERROR\n");
				pvm_exit();
				exit(1);
			}
			break;
	default :	
			
			break;
	}
 } // end of while loop
return (OK);
} 

int ProcessGetWorkerClassId(char *fname, char *wcname, int ctid)
{
int	sbufid;
int 	ret;
FItem 	*fitem;
WCItem 	*wcitem;

	// Search for the farm item by farm name
	fitem = farm->Search(fname); 
	if (fitem == (FItem *) NULL)
	{ // such a farm name does not exist in the farm list
		ret = FARM_NOT_CREATED; // Error 
	}
	else 
	{
		if(fitem -> WCList_ptr != (WCList *) NULL)
		{ // there's a worker class list!
		 // search for worker class item by wcname
			wcitem = fitem->WCList_ptr->SearchByName(wcname);
			if (wcitem == (WCItem *) NULL)
			{
			// worker class is not created yet ->Pending
				info = pending->Append(GET_WORKER_CLASS_ID,
			fname, wcname, ctid);
				if(info == ERROR) return (ERROR);
				else return (OK);
			}
			// So, there's a worker class and its found
			ret = wcitem -> wcid; // the worker class id
		}
		else
		{ // there's no wclist => no worker class item!
			info = pending-> Append(GET_WORKER_CLASS_ID,
				fname, wcname, ctid);
			// Put it on the list of pending requests
			if(info == ERROR) return (ERROR);
			else return (OK);
		}
	}
	// Here we have ret containing the return value which is
	// either the wcid or FARM_NOT_CREATED. This has to be sent.
		 
	// operation successful. Now send the worker class id back
	sbufid = pvm_mkbuf(PvmDataDefault); // makes buffer
	ASSERT(sbufid); // Check if sbufid < 0

	info = pvm_setsbuf(sbufid); // sets this one as
	ASSERT(info); // Check if info < 0
	// the active send buffer. It'll be used

	info = pvm_pkint(&ret, 1, 1); // 1 item, stride = 1
	ASSERT(info); // Check if info < 0

	info = pvm_send(ctid, DEF_MSGTAG);
	ASSERT(info); // Check if info < 0
	// send the worker class id to the client

	info = pvm_freebuf(sbufid);
	ASSERT(info); // Check if info < 0

	return (OK);
}

int ProcessInitWorkerClass(char *fname, char *wcname, int ctid)
{
FItem 	*fitem;
WCItem  *wcitem;	
int 	sbufid; // send buffer id
int	wclassid; // worker class id
int 	ftid; // farmer tid
char	wname[NAMELEN]; // worker name

	fitem = farm->Search(fname); // Search for the farmer
	if (fitem == (FItem *) NULL) // farmer not found
	{
		info = pending->Append(INIT_WORKER_CLASS, fname,
			wcname, ctid); 
	// opcode, farmer name, worker class name, task id --> PENDING request
		return (OK);
	}
	// farmer is found. Enroll this in the farmer.
	ftid = fitem->tid; // store farmer tid for sending to worker task
	if(fitem->WCList_ptr == (WCList *) NULL)
	{ // there are no worker classes associated with the farmer yet
		fitem->WCList_ptr = new WCList(); // create a WClist
		if (fitem->WCList_ptr == (WCList *) NULL)
			return (ERROR); // MALLOC ERROR
	}
	// So, the list of worker classes is established. Now
	// We need to see if the worker class wcname is there
	wcitem = fitem->WCList_ptr->SearchByName(wcname);

	if (wcitem == (WCItem *) NULL)
	{ // i.e., such a worker class doesn't exist -> Create it!
 	//Now there is a worker class established. Give back the id

        	wclassid = GetNewWCID(); // get a unique worker class id 
		if (wclassid > MAX_WORKER_CLASSES - 1)
		{ 
			return (ERROR); // limit exceeded.
		}
       		info = fitem->WCList_ptr -> Append(wcname,wclassid);
			//create an item 
       		if (info == ERROR)
			return (ERROR); // Memory allocation error 
		fitem->number_of_worker_classes ++; 
			// increment the number of worker classes
		wcitem = fitem->WCList_ptr->Search(wclassid);
		// get access to the worker class item   
		// Put the entry in the cache of worker classes and wcids.
		wccache[wclassid] = wcitem; 
		// This is only needed when this is created
	}
	else
	{ // we have a worker class established earlier. get the 
	// item and see the wcid  
		wclassid = wcitem->wcid; // see the worker class id
	}
	// At this stage, both wclassid and wcitem are correct
	
	// Now enroll the task in the worker list
	//first access the worker class item and then use that
	// now that we have the worker class item, access the worker

	if( wcitem->WList_ptr == (WList *) NULL) // there's no list
	{ // create a list
		wcitem->WList_ptr = new WList(); // created a worker list
		if (wcitem->WList_ptr == (WList *) NULL) 
			return (ERROR); // MALLOC error
	}
	// now there's a worker list.
	GetTaskName(ctid, wname); // get worker name
	info = wcitem->WList_ptr->Append(wname, ctid); // add a worker	
	if (info == ERROR)
		return (ERROR); //MALLOC error
	// otherwise, successfully added a worker task
	wcitem->number_of_workers ++; // add a worker
		

	// operation successful. Now send the worker class id back
	sbufid = pvm_mkbuf(PvmDataDefault); // makes buffer
	ASSERT(sbufid); // Check if < 0

	info = pvm_setsbuf(sbufid); // sets this one as
	// the active send buffer. It'll be used
	ASSERT(info); // Check if info < 0

	info = pvm_pkint(&wclassid, 1, 1); // 1 item, stride = 1, wcid
	ASSERT(info); // Check if info < 0

	info = pvm_pkint(&ftid, 1, 1); // 1 item, farmer tid
	ASSERT(info); // Check if info < 0

	info = pvm_send(ctid, DEF_MSGTAG);
	// send the worker class id to the client
	ASSERT(info); // Check if info < 0

	info = pvm_freebuf(sbufid);
	// free the buffer created temporarily
	ASSERT(info); // Check if info < 0

	ProcessPending(); // If it has reached here, then the 
	// request was serviced successfully -> check for pending
	// requests.

		
	return (OK);
}
	
int	ProcessInitFarm(char *fname, int ctid)
{
	FItem 	*fitem;
	int	sbufid,ret;
	
	fitem = farm->Search(fname); // Search for the farm
	if (fitem == (FItem *) NULL)// Farm is not present
	{
		info = farm->Append(fname,ctid); // Make a new farmer item
		if (info == ERROR)
			ret = ERROR;
		else
			ret = OK;
	}
	else
	{
		ret = FARM_NAME_PRESENT; // already a farm with
		// the given name exists - prog. error - user
	}

	sbufid = pvm_mkbuf(PvmDataDefault); // makes buffer
	ASSERT(sbufid); // Check if sbufid < 0

	info = pvm_setsbuf(sbufid); // sets this one as
	// the active send buffer. It'll be used
	ASSERT(info); // Check if info < 0

	info = pvm_pkint(&ret, 1, 1); // 1 item, stride = 1
	ASSERT(info); // Check if info < 0

	info = pvm_send(ctid, DEF_MSGTAG);
	// send the worker class id to the client
	ASSERT(info); // Check if info < 0

	info = pvm_freebuf(sbufid);
	ASSERT(info); // Check if info < 0

	if(ret == OK) // farm added check for pending requests
		ProcessPending(); // process pending requests
	if (ret != ERROR) 	
		return (OK);
	else
		return (ERROR);
}
int	ProcessPending(void)
{
	int i,N;
	PItem *pitem;
	
	N = pending->no_of_items;
	
	for (i=0;i<N;i++)
	{
		pitem = pending->Pop(); // remove an item
		if (pitem == (PItem *) NULL)
		{	printf("ProcessPending() : N = %d\n", N);
			return (OK); // no more pending requests
		}
		switch(pitem->opcode) 
		{	
		case GET_WORKER_CLASS_ID :
			ProcessGetWorkerClassId(pitem->farm_name,
			pitem->worker_class_name,pitem->tid);
			// send this request for processing
			break;
		case INIT_WORKER_CLASS:
			ProcessInitWorkerClass(pitem->farm_name,
			pitem->worker_class_name,pitem->tid);
			// send this request for processing
			break;
		}
		delete pitem; // free up the memory
	}
		
	return (OK);
}


int GetTaskName(int tid,char *name)
{
	// this routine can be used to get a.out name of a task specified 
	// by a tid.

	int ret;
	int	ntasks,i;
	struct taskinfo *taskp;
	
	ret = pvm_tasks(0,&ntasks,&taskp);
	if (ret != 0)
	{
		printf("Error in SearchForServer(): pvm_tasks returns %d\n",ret);	
		pvm_exit();
		exit(1);
	}
	// So now the taskp contains the information
	for (i=0; i< ntasks;i++)
	{
		if (tid == taskp[i].ti_tid)
		{
			// found the task tid 
			strcpy(name,taskp[i].ti_a_out);
			return (1);
		}
	}
	return (-1); // not found 
}

int	GetNewWCID(void)
{
	return (gwcid++);
}

int print_junk(void)
{
	int i;
	
	for(i=0;i< 100; i++)
	{
		printf("Server is working!!\n");
	}
	return (OK);
}


int	ProcessFarmTerminate(char *farm_name, int ftid)
{
FItem 	*fitem;
WCItem	*wcitem;
WItem	*witem;
int	ret,sbufid;

	ret = OK; // initialise	
	fitem = farm->Search(farm_name);
	if (fitem == (FItem *) NULL)
		// NO SUCH FARM
	// Send message to the farmer saying that there's NO_SUCH_FARM
	{
		ret = NO_SUCH_FARM;	
	}
	else { // NO_SUCH_FARM
	
	if (fitem -> tid != ftid)
	// Some other process trying to destroy a farm made by another task
	{
		ret = NOT_FARM_OWNER; // did not create the farm
	}

	if (ret == OK) //  found the item and everything is fine
	{	
	
		// get all worker classes, and all tasks in each and 
		// send a message saying that the farm has terminated
		while ((wcitem = fitem -> WCList_ptr -> Pop()) != (WCItem *) NULL)
		{ // get one wcitem at a time
			ResetWCCache(wcitem -> wcid); // reset the cache
			while ((witem = wcitem -> WList_ptr -> SearchNoPending()) != (WItem *) NULL)
			{ // get each worker that is waiting
			  // send a message that the farm has terminated
			 sbufid = pvm_mkbuf(PvmDataDefault); // makes buffer
			 ASSERT(sbufid); // Check if sbufid < 0

       			 info = pvm_setsbuf(sbufid); // sets this one as
        		 // the active send buffer. It'll be used
			 ASSERT(info); // Check if info < 0

			 ret = FARM_HAS_TERMINATED ; 
        		 info = pvm_pkint(&ret, 1, 1); // 1 item, stride = 1
			 ASSERT(info); // Check if info < 0

			 info = pvm_send(witem -> tid, FARM_HAS_TERMINATED);
        		 // send the message to each worker waiting for it
			 ASSERT(info); // Check if info < 0

        		 info = pvm_freebuf(sbufid);
			 ASSERT(info); // Check if info < 0
			
			 witem -> packets_pending = 1; // so that next call 
				// to SearchNoPending does not return the
				// same item
			 // go on doing this till there are no worker tasks
			}

			// All the waiting tasks were sent a message that the
			// farm has terminated.
			// Now delete everything in worker class
	
			delete wcitem -> WList_ptr ; // delete all workers
			delete wcitem -> WPList_ptr ; // and all pending
				// work packets. Farm has been destroyed.
		}
		// Now delete all worker classes associated with the farm
	
		delete fitem -> WCList_ptr ;
		// And at the end, we need to delete the farm item too.
		farm -> Delete(farm_name);

		ret = OK; // everything went off well
		// Send a message to the farmer saying that farm was deleted 
		// ret contains OK use it to say OK to farmer. 	
	} // ret == OK
	} // NO_SUCH_FARM

	
	sbufid = pvm_mkbuf(PvmDataDefault); // makes buffer
	ASSERT(sbufid); // Check if sbufid < 0

       	info = pvm_setsbuf(sbufid); // sets this one as
       	// the active send buffer. It'll be used
	ASSERT(info); // Check if info < 0

     	info = pvm_pkint(&ret, 1, 1); // 1 item, stride = 1
	// ret contains OK or NO_SUCH_FARM or NOT_FARM_OWNER
	ASSERT(info); // Check if info < 0

	info = pvm_send(ftid, DEF_MSGTAG);
        // send the message to each worker waiting for it
	ASSERT(info); // Check if info < 0

        info = pvm_freebuf(sbufid);
	ASSERT(info); // Check if info < 0
			
	return (OK);
}
