#include <pvm3.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "pvmfarm.h"

#define	PKTS	4

main(int argc, char **argv)
{
	int wcid,i,val,sbufid, data,cc,dt2,ret,wcid11;
	int	*tid, N;
	char wcname[32];

	pvm_start_farmd(); // start app
	pvm_farm_init("Farm 001");
	pvm_farm_init("Farm 002");

	if(argc > 1)
		N = atoi(argv[1]);
	else
		N = 3;

	tid = new int[N];
	cc = pvm_spawn("cl2", (char**)0, 0, "", N, tid);
	printf("Spawned %d tasks of cl2\n",N);

	tid = new int[N];
	cc = pvm_spawn("cl3", (char**)0, 0, "", N, tid);
	printf("Spawned %d tasks of cl3\n",N);

	wcid = pvm_get_worker_class_id("Farm 001", "Wrk Clss 0");
	wcid11 = pvm_get_worker_class_id("Farm 002", "Wrk Clss 1");

	for(i=0; i< N*PKTS; i++)
	{
		data = 1000+i; // send this data to the worker

		sbufid = pvm_mkbuf(PvmDataDefault);
	
		pvm_setsbuf(sbufid); // set this as the sending buffer
		pvm_pkint(&data, 1, 1); // pack the data in it
		dt2 = 1000 + i *2;
		pvm_pkint(&dt2, 1, 1); // pack the data in it
	
		pvm_send_work_packet(wcid); // send the wp
		pvm_freebuf(sbufid); // free up the buffer
	}
	for(i=0; i< N*PKTS; i++)
	{
		data = 2000+i; // send this data to the worker

		sbufid = pvm_mkbuf(PvmDataDefault);
	
		pvm_setsbuf(sbufid); // set this as the sending buffer
		pvm_pkint(&data, 1, 1); // pack the data in it
		dt2 = 20000 + i *2;
		pvm_pkint(&dt2, 1, 1); // pack the data in it
	
		pvm_send_work_packet(wcid11); // send the wp
		pvm_freebuf(sbufid); // free up the buffer
	}
	
	
	for(i=0;i<N*PKTS;i++)
	{
		pvm_recv_reply_packet(wcid); 
		
		pvm_upkint(&val,1,1); // remove the value
		if (val == 1116)
		printf("FARMER Received %d, iteration = %d\n", val,i);
		else
		{
		printf("PANIC !!! received wrong data \n");
		exit(1);
		}
	}
	for(i=0;i<N*PKTS;i++)
	{
		pvm_recv_reply_packet(wcid11); 
		
		pvm_upkint(&val,1,1); // remove the value
		if(val == 1117)
		printf("FARMER Received %d, iteration = %d\n", val,i);
		else
		{
		printf("PANIC !!! received wrong data \n");
		exit(1);
		}
	}
	ret = pvm_farm_terminate("Farm 001"); // terminate the farm
	if (ret < 0)
	{
		printf("ERROR in farm terminate ret = %d\n", ret);
	}
	ret = pvm_farm_terminate("Farm 002"); // terminate the farm
	if (ret < 0)
	{
		printf("ERROR in farm terminate ret = %d\n", ret);
	}
#ifdef PFT
#endif
	sleep(8);

	pvm_stop_farmd(); // stop the farmer daemon
	pvm_exit();
}


