#include <pvm3.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pvmfarm.h>


main(int argc, char **argv)
{
	int wcid,i,val,sbufid, data,cc,dt2,ret;
	int	*tid, N;
	char wcname[32];

	pvm_start_farmd(); // start app
	pvm_farm_init("Farm 001");

	if(argc > 1)
		N = atoi(argv[1]);
	else
		N = 5;

	tid = new int[N];
	cc = pvm_spawn("cl2", (char**)0, 0, "", N, tid);
	printf("Spawned %d tasks of cl2\n",N);

	wcid = pvm_get_worker_class_id("Farm 001", "Wrk Clss 0");

	for(i=0; i< N*100; i++)
	{
		data = 5000+i; // send this data to the worker

		sbufid = pvm_mkbuf(PvmDataDefault);
	
		pvm_setsbuf(sbufid); // set this as the sending buffer
		pvm_pkint(&data, 1, 1); // pack the data in it
		dt2 = 1000 + i *2;
		pvm_pkint(&dt2, 1, 1); // pack the data in it
	
		pvm_send_work_packet(wcid); // send the wp
		pvm_freebuf(sbufid); // free up the buffer
	}
	
	for(i=0;i<N*100;i++)
	{
		pvm_recv_reply_packet(wcid); 
		
		pvm_upkint(&val,1,1); // remove the value
	//	printf("FARMER Received %d, iteration = %d\n", val,i);
	}
	ret = pvm_farm_terminate("Farm 001"); // terminate the farm
	if (ret < 0)
	{
		printf("ERROR in farm terminate ret = %d\n", ret);
	}
#ifdef PFT
#endif

	pvm_stop_farmd(); // stop the farmer daemon
	pvm_exit();
}


