#include <pvm3.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pvmfarm.h>

main(int argc, char **argv)
{
	int wcid,i,val,sbufid, data,cc,dt2,ret;
	int	*tid, N;
	char wcname[32];

	pvm_start_farmd(); // start app
	pvm_farm_init("Farm 001");

	if(argc > 1)
		N = atoi(argv[1]);
	else
		N = 2;

	tid = new int[N];
	cc = pvm_spawn("cl2", &argv[1], 0, "majestix", 1, &tid[0]);
	ASSERT(cc);
	cc = pvm_spawn("cl2", &argv[1], 0, "atlantix", 1, &tid[1]);
	ASSERT(cc);

	wcid = pvm_get_worker_class_id("Farm 001", "Wrk Clss 0");
	ASSERT(wcid);

	for(i=0; i< N; i++)
	{
		data = 5000+i; // send this data to the worker

		sbufid = pvm_mkbuf(PvmDataDefault);
		ASSERT(sbufid);

	
		cc = pvm_setsbuf(sbufid); // set this as the sending buffer
		ASSERT(cc);

		cc = pvm_pkint(&data, 1, 1); // pack the data in it
		ASSERT(cc);
		dt2 = 1000 + i *2;
		cc = pvm_pkint(&dt2, 1, 1); // pack the data in it
		ASSERT(cc);
	
		cc = pvm_send_work_packet(wcid); // send the wp
		ASSERT(cc);
		cc = pvm_freebuf(sbufid); // free up the buffer
		ASSERT(cc);
	}
	
	for(i=0;i<N;i++)
	{
		cc = pvm_recv_reply_packet(wcid); 
		ASSERT(cc);
		
		cc = pvm_upkint(&val,1,1); // remove the value
		ASSERT(cc);
	//	printf("FARMER Received %d, iteration = %d\n", val,i);
	}
	ret = pvm_farm_terminate("Farm 001"); // terminate the farm
	if (ret < 0)
	{
		printf("ERROR in farm terminate ret = %d\n", ret);
	}
#ifdef PFT
#endif

	cc = pvm_stop_farmd(); // stop the farmer daemon
	ASSERT(cc);
	cc = pvm_exit();
	ASSERT(cc);
}


