#include <pvm3.h>
#include <stdio.h>
#include <sysent.h>
#include <string.h>
#include <incl.h>


int SearchForServer(char *name)
{
	int ret;
	int	ntasks,i;
	struct taskinfo *taskp;
	
	ret = pvm_tasks(0,&ntasks,&taskp);
	if (ret != 0)
	{
		printf("Error in SearchForServer(): pvm_tasks returns %d\n",ret);	
		pvm_exit();
		exit(1);
	}
	// So now the taskp contains the information
	for (i=0; i< ntasks;i++)
	{
		if (!strcmp(name,taskp[i].ti_a_out))
		{ //matches perfectly so we have the name
			return (taskp[i].ti_tid);
		}
	}	
	return (-1);
}

int GetTaskName(int tid,char *name)
{
	// this routine can be used to get a.out name of a task specified 
	// by a tid.

	int ret;
	int	ntasks,i;
	struct taskinfo *taskp;
	
	ret = pvm_tasks(0,&ntasks,&taskp);
	if (ret != 0)
	{
		printf("Error in SearchForServer(): pvm_tasks returns %d\n",ret);	
		pvm_exit();
		exit(1);
	}
	// So now the taskp contains the information
	for (i=0; i< ntasks;i++)
	{
		if (tid == taskp[i].ti_tid)
		{
			// found the task tid 
			strcpy(name,taskp[i].ti_a_out);
			return (1);
		}
	}
	return (-1); // not found 
}

main()
{
	int cc, tid,stid,ret;
	char buf[100],buf2[100],myname[128];
	FList *f;

	gethostname(buf2, 64);
	printf("i'm The new t%x running on %s\n", pvm_mytid(),buf2);

	cc = pvm_spawn("hello_other", (char**)0, 0, "", 1, &tid);
	if ((stid = SearchForServer("hello_other")) != -1)
	{
		printf("Found Server : stid = %x\n",stid);
	}
	else
	{
		printf("Couldn't locate the server task\n");
	}
	ret = GetTaskName(tid,myname);
	if (ret > 0)
	{
		printf("Found hello_other name = %s\n", myname);
	}
	else
	{
		printf("ERROR !: Couldn't locate tid = %d\n",pvm_mytid());
		exit(1);
	}

	if (cc == 1) {
		cc = pvm_recv(-1, -1);
		pvm_bufinfo(cc, (int*)0, (int*)0, &tid);
		pvm_upkstr(buf);
		printf("from t%x: %s\n", tid, buf);

	} else
		printf("Couldn't start hello_other\n");
	f = new FList();
	f->Append("Farm1",pvm_mytid());
	f->Display();

	pvm_exit();
}


