#include <pvm3.h>
#include <stdio.h>
#include <string.h>
#include "pvmfarm.h"
#include "mat.h"

/* global variables */
extern float **C;

float *data;
main(int argc, char **argv)
{
	int wcid,i,bufid;
	int ret,buf,count;
	char wcname[32],host[256];
	int row, size;


	if(argc > 1) size = atoi(argv[1]);
	else	     size = DEFAULT;

	data = new float[size]; 

	initialise_matrices(size);
	pvm_init_worker_class("Matrix","RowWorker"); 

	count = 0;
	while(1)
	{
	bufid = pvm_recv_work_packet();

	if (bufid == PvmFarmHasTerminated)
		break;

	count++;
	pvm_upkint(&row, 1, 1); // unpack the data	
//	printf("Worker received %d\n", row);
	buf = pvm_mkbuf(PvmDataDefault);
	pvm_setsbuf(buf);
	pvm_pkint(&row,1,1);
	// First tell which row is being sent
	
	multiply_matrices(size, row);
	for(i=0;i<size;i++)
		data[i] = C[row][i];

	pvm_pkfloat(data,size, 1); //then send the row
	pvm_send_reply_packet();
	pvm_freebuf(buf);
	}
	gethostname(host,64);
//	printf("%x Worker on host %s processed %d packets exiting ...\n", pvm_mytid(),host, count);

	free_matrices(size);
	pvm_exit();
}


